from . import admin_bp
from flask_login import login_required
from app.auth.decorators import admin_required
from .UserController import userController

@admin_bp.route("/admin/users/")
@login_required
@admin_required
def list_users():
    return userController.list_users()

@admin_bp.route("/admin/user/", methods=['GET', 'POST'])
@login_required
@admin_required
def user_form():
    return userController.user_form()

@admin_bp.route("/admin/user/<int:user_id>/", methods=['GET', 'POST'])
@login_required
@admin_required
def update_user_form(user_id):
    return userController.update_user_form(user_id)
    
@admin_bp.route("/admin/user/delete/<int:user_id>/", methods=['POST'])
@login_required
@admin_required
def delete_user(user_id):
    return userController.delete_user(user_id)
