import logging
from flask import abort, render_template, current_app
from app.models import Proyecto
from . import public_bp
from werkzeug.exceptions import NotFound

logger = logging.getLogger(__name__)

@public_bp.route("/")
def index():
    #current_app.logger.info('Mostrando los proyectos')
    #logger.info('Mostrando los proyectos')
    proyectos = Proyecto.get_all()
    return render_template("public/index.html", num_proyectos=len(proyectos))

@public_bp.route("/proyecto/<string:slug>/")
def show_proyecto(slug):
    proyecto = Proyecto.get_by_slug(slug)
    if proyecto is None:
        raise NotFound(slug)
    return render_template("public/proyecto_view.html", slug_title=slug)