from flask_wtf import FlaskForm
from wtforms.fields.simple import MultipleFileField
from flask_wtf.file import  FileAllowed
from wtforms.validators import DataRequired, Length
from wtforms import (StringField, SubmitField, IntegerField, TextAreaField, BooleanField,  SelectField, validators)

class ProyectoForm(FlaskForm):
    nombre = StringField('Nombre del proyecto',  validators=[DataRequired(message="Ingrese el nombre del proyecto"), Length(max=256)])
    descripcion = TextAreaField('Descripción general del proyecto')
    distancia_palabras = IntegerField('Digite el número de palabras a tener en cuenta para calcular la relación entre los actores', validators=[validators.DataRequired(message="Ingrese un número válido")])
    modelo_ner = SelectField('Seleccione el modelo de reconocimiento de actores a utilizar en el proyecto', coerce=int, validators=[validators.DataRequired(message="Seleccione el modelo ner a utilizar")])
    submit = SubmitField('Enviar')

class ProyectoDeleteForm(FlaskForm):
    proyecto_id = IntegerField(validators=[validators.DataRequired(message="Debe enviar los datos de un proyecto válido")])

class DcoumentoDeleteForm(FlaskForm):
    documento_id = IntegerField(validators=[validators.DataRequired(message="Debe enviar los datos de un documento válido")])

class UserAdminForm(FlaskForm):
    is_admin = BooleanField('Administrador')
    submit = SubmitField('Guardar')

class CreateDocumentsForm(FlaskForm):
    documentos = MultipleFileField('Documentos', validators=[validators.DataRequired(message="Debe cargar al menos un archivo"),
                                            FileAllowed(['pdf'], "wrong format!")])
    submit = SubmitField('Cargar')

    