from . import registered_bp
from flask_login import login_required, current_user
from .ProyectoController import proyectoController

@registered_bp.route("/registered/")
@login_required
#@admin_required
def index():
    return proyectoController.index()

@registered_bp.route("/registered/proyectos/")
@login_required
#@admin_required
def list_proyectos():
    return proyectoController.list_proyectos()
#     proyectos = Proyecto.get_all()
#     form = ProyectoDeleteForm()
#     return render_template("registered/proyectos.html", proyectos=proyectos, form=form)

@registered_bp.route("/registered/proyecto/", methods=['GET', 'POST'], defaults={'proyecto_id': None})
@login_required
#@admin_required
def proyecto_form(proyecto_id=None):
    return proyectoController.proyecto_form()
#     form = ProyectoForm()
#     modelos_ner = [(c.id, c.nombre) for c in ModeloNer.query.all()]
#     form.modelo_ner.choices = modelos_ner
#     if form.validate_on_submit():
#         proyecto = Proyecto(nombre = form.nombre.data,
#                             descripcion = form.descripcion.data,
#                             distancia_palabras = form.distancia_palabras.data,
#                             user_id=current_user.id, 
#                             modelo_ner_id = form.modelo_ner.data)
#         proyecto.save()
#         return redirect(url_for('registered.list_proyectos'))
#     return render_template("admin/proyecto_form.html", form=form)

@registered_bp.route("/registered/proyecto/<int:proyecto_id>/", methods=['GET'])
@login_required
#@admin_required
def show_proyecto(proyecto_id):
    return proyectoController.show_proyecto(proyecto_id)
#     proyecto = Proyecto.get_by_id(proyecto_id)
    
#     if proyecto is None:
#         logger.info(f'El proyecto {proyecto_id} no existe')
#         abort(404)
    
#     form = DcoumentoDeleteForm()
#     return render_template("registered/proyecto.html", proyecto=proyecto, form=form)

@registered_bp.route("/registered/proyecto/<int:proyecto_id>/update/", methods=['GET', 'POST'])
@login_required
#@admin_required
def update_proyecto_form(proyecto_id):
    return proyectoController.update_proyecto_form(proyecto_id)
#     proyecto = Proyecto.get_by_id(proyecto_id)
    
#     if proyecto is None:
#         logger.info(f'El post {proyecto_id} no existe')
#         abort(404)
#     # Crea un formulario inicializando los campos con
#     # los valores del proyecto.
#     form = ProyectoForm(obj=proyecto)
#     modelos_ner = [(c.id, c.nombre) for c in ModeloNer.query.all()]
#     form.modelo_ner.choices = modelos_ner
#     if form.validate_on_submit():
#         # Actualiza los campos del proyecto existente
#         proyecto.nombre = form.nombre.data,
#         proyecto.descripcion = form.descripcion.data,
#         proyecto.distancia_palabras = form.distancia_palabras.data,
#         proyecto.user_id=current_user.id, 
#         proyecto.modelo_ner_id = form.modelo_ner.data
#         proyecto.save()
#         logger.info(f'Guardando el proyecto {proyecto_id}')
#         return redirect(url_for('registered.list_proyectos'))
#     return render_template("registered/proyecto_form.html", form=form, proyecto=proyecto)


@registered_bp.route("/registered/proyecto/<int:proyecto_id>/delete/", methods=['POST'])
@login_required
#@admin_required
def delete_proyecto(proyecto_id):
    return proyectoController.delete_proyecto(proyecto_id)
#     logger.info(f'Se va a eliminar el proyecto {proyecto_id}')
#     post = Proyecto.get_by_id(proyecto_id)
#     if post is None:
#         logger.info(f'El proyecto {proyecto_id} no existe')
#         abort(404)
#     post.delete()
#     logger.info(f'El proyecto {proyecto_id} ha sido eliminado')
#     return redirect(url_for('registered.list_proyectos'))


@registered_bp.route("/registered/proyecto/<int:proyecto_id>/crate-document", methods=['GET', 'POST'])
@login_required
#@admin_required
def create_document(proyecto_id):
    return proyectoController.create_document(proyecto_id)
#     proyecto = Proyecto.get_by_id(proyecto_id)
    
#     if proyecto is None:
#         logger.info(f'El proyecto {proyecto_id} no existe')
#         abort(404)
    
#     form = CreateDocumentsForm()

#     if form.validate_on_submit():
#         for file in form.documentos.data:
#             documento = Documento()
#             documento.nombre = file.filename
#             file_filename = secure_filename(file.filename)
#             documents_dir = current_app.config['PROYECTOS_DOCUMENTS_DIR'] + os.path.sep + str(proyecto_id) + os.path.sep
#             os.makedirs(documents_dir, exist_ok=True)
#             file_path = os.path.join(documents_dir, file_filename)
#             documento.ubicacion = file_path
#             documento.proyecto=proyecto
#             file.save(file_path)
#             db.session.add(documento)
        
#         db.session.commit()
        
#         return redirect(url_for('registered.show_proyecto', proyecto_id=proyecto_id))


#     return render_template("registered/create_document.html", proyecto=proyecto, form=form)

@registered_bp.route("/registered/proyecto/<int:proyecto_id>/delete-document/<int:documento_id>", methods=['POST'])
@login_required
#@admin_required
def delete_documento(proyecto_id, documento_id):
    return proyectoController.delete_documento(proyecto_id, documento_id)
#     logger.info(f'Se va a eliminar el documento {documento_id}')
#     documento = Documento.get_by_id(documento_id)
#     if documento is None:
#         logger.info(f'El documento {documento_id} no existe')
#         abort(404)
    
#     documento.delete()
#     if os.path.isfile(documento.ubicacion):
#         os.remove(documento.ubicacion)
#     logger.info(f'El proyecto {documento_id} ha sido eliminado')

#     return redirect(url_for('registered.show_proyecto', proyecto_id=proyecto_id))

@registered_bp.route("/registered/proyecto/<int:proyecto_id>/identify-actors/", methods=['GET'])
@login_required
#@admin_required
def identify_actors(proyecto_id):
    return proyectoController.identify_actors(proyecto_id)
#     logger.info(f'Se van a identificar actores del proyecto {proyecto_id}')
#     proyecto = Proyecto.get_by_id(proyecto_id)
#     if proyecto is None:
#         logger.info(f'El proyecto {proyecto_id} no existe')
#         abort(404)
    
#     sentence= """Mitos y Realidades de los Alimentos Funcionales. Trabajo de Grado, 
#                 Facultad de Medicina Veterinaria y Zootecnia, Universidad Nacional de Colombia, Bogotá
#                 La cadena de Aguacate se encuentra sostenida por organizaciones como Agrosabia en 
#                 Investigación y transferencia tecnológica, 
#                 el ICA en control fitosanitario, el SENA y la Universidad Nacional en capacitación y 
#                 transferencia de paquetes tecnológicos, Procolombia y la Corporación Colombia Internacional CCI 
#                 en fomento y apoyo financiero"""

#     dir_model = current_app.config['MODELOS_DOCUMENTS_DIR'] + os.path.sep + 'modelo-tok2vec'
#     """Se debe consultar el modelo en la base de datos"""
    
#     graph = GenerateGraph()

#     files_path= current_app.config['PROYECTOS_DOCUMENTS_DIR'] + os.path.sep + str(proyecto.id)
#     files = os.listdir(files_path) 
#     files = [f for f in os.listdir(files_path) if os.path.isfile(os.path.join(files_path, f))]
#     #logger.info(f'Archivos:  {files}')
#     todos = ''
#     relations=[]
#     for file in files:
#         #print(os.path.join(files_path, file))
#         text_pdf = extract_text_from_pdf(os.path.join(files_path, file))
#         #print(text_pdf)
#         text_pdf = clean_text(text_pdf)
#         actors_list = ActorRecognition(text_pdf, dir_model).getActors()
#         extract_relations = ExtracRelations(text_pdf, actors_list)
#         file_relations = extract_relations.getRelationships()
#         relations = list(set().union(relations,file_relations))
#         #tomar relations y crear lista de relaciones con nombres del actor
#         #para esto se deben buscar en la tabla actores los nombres que vienen en la relación
#         #y si no existen se busca si aparece como sinonimo
#         #acá se puede crear un diccionario en python con los actores y sus sinonimos
#         # actor = actor + actor=sinonimo, y así ahorrar busquedas en la BD
    
#     actor_rel = ActorRelations()
#     relations_out_sinonimos = actor_rel.replaceNamesRelations(relations)

#     #Encontrados
#     #print('Relaciones sin sinonimos')
#     #print(relations_out_sinonimos)
#     graph.generateDBGraph(relations_out_sinonimos)
        
#     #    if entidades > 0:
#     #        print([(ent.text, ent.label_) for ent in entidades])

#     #text = sentence.replace(',', ' ,')
#     #text = " ".join(text.split())
#     #logger.info(f'Oración:  {sentence}')
    
#     #actors_list = ActorRecognition(sentence, dir_model).getActors()
#     #print('Listado de actores: ')
#     #print(actors_list)
#     #actors_text = ', '.join([str(item) for item in actors_list])
#     #extract_relations = ExtracRelations(sentence, actors_list)
#     #relations = extract_relations.getRelationships()
#     #print('Realciones: ')
#     #print(relations)
    
#     #graph.generateDBGraph(relations)

#     return render_template("registered/show_actors.html", proyecto=proyecto, actors=todos)

# """ Funcionalidades para pasar a módulo administrador """
# @registered_bp.route("/admin/users/")
# @login_required
# #@admin_required
# def list_users():
#     users = User.get_all()
#     return render_template("registered/users.html", users=users)

# @registered_bp.route("/registered/user/<int:user_id>/", methods=['GET', 'POST'])
# @login_required
# #@admin_required
# def update_user_form(user_id):
#     # Aquí entra para actualizar un usuario existente
#     user = User.get_by_id(user_id)
#     if user is None:
#         logger.info(f'El usuario {user_id} no existe')
#         abort(404)
#     # Crea un formulario inicializando los campos con
#     # los valores del usuario.
#     form = UserAdminForm(obj=user)
#     if form.validate_on_submit():
#         # Actualiza los campos del usuario existente
#         user.is_admin = form.is_admin.data
#         user.save()
#         logger.info(f'Guardando el usuario {user_id}')
#         return redirect(url_for('admin.list_users'))
#     return render_template("registered/user_form.html", form=form, user=user)

# @registered_bp.route("/registered/user/delete/<int:user_id>/", methods=['POST', ])
# @login_required
# #@admin_required
# def delete_user(user_id):
#     logger.info(f'Se va a eliminar al usuario {user_id}')
#     user = User.get_by_id(user_id)
#     if user is None:
#         logger.info(f'El usuario {user_id} no existe')
#         abort(404)
#     user.delete()
#     logger.info(f'El usuario {user_id} ha sido eliminado')
#     return redirect(url_for('registered.list_users'))