from app.utils.neo4j_connection import Neo4jConnection

class GenerateGraph:

    constraint_query="CREATE CONSTRAINT ON (p:Actor) ASSERT p.name IS UNIQUE;"

    def __init__(self):
        try:
            self.save_query ="""
            MERGE (p1:Actor{name:$name1})
            MERGE (p2:Actor{name:$name2})
            MERGE (p1)-[r:RELATED]-(p2)
            ON CREATE SET r.score = 1
            ON MATCH SET r.score = r.score + 1"""
            self.conn = Neo4jConnection(uri="bolt://localhost:7687", user="neo4j", pwd="neo4j1234.")
            #comentar en producción, por que el licenciamiento de neo4j, no permite tener más de una BD
            self.conn.query("CREATE OR REPLACE DATABASE agriot")
            self.conn.query("MATCH (n) DETACH DELETE n", db='agriot')

        except:
            print("Error de conexión a Neo4j")



    def generateDBGraph(self, entityRelations):
        #self.conn.query("CREATE OR REPLACE DATABASE agriot")
        
        for tup in entityRelations:
            params = {'name1':tup[0],'name2':tup[1]}
            self.conn.query(self.save_query, params=params, db='agriot')
        #    print(tup[0], "-", tup[1])


