"""Añade las tablas de Actor, TipoActor, Nivel y Sector

Revision ID: 10612a420679
Revises: 6ac1a5cd22a5
Create Date: 2022-01-22 12:04:36.422650

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '10612a420679'
down_revision = '6ac1a5cd22a5'
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('nivel',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('sector',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('tipo_actor',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('actor',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.Column('nivel_id', sa.Integer(), nullable=False),
    sa.Column('sector_id', sa.Integer(), nullable=False),
    sa.Column('tipo_actor_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['nivel_id'], ['nivel.id'], ),
    sa.ForeignKeyConstraint(['sector_id'], ['sector.id'], ),
    sa.ForeignKeyConstraint(['tipo_actor_id'], ['tipo_actor.id'], ),
    sa.PrimaryKeyConstraint('id')
    )
    op.drop_constraint('proyecto_ibfk_1', 'proyecto', type_='foreignkey')
    op.create_foreign_key(None, 'proyecto', 'modelo_ner', ['modelo_ner_id'], ['id'])
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'proyecto', type_='foreignkey')
    op.create_foreign_key('proyecto_ibfk_1', 'proyecto', 'modelo_ner', ['modelo_ner_id'], ['id'], ondelete='CASCADE')
    op.drop_table('actor')
    op.drop_table('tipo_actor')
    op.drop_table('sector')
    op.drop_table('nivel')
    # ### end Alembic commands ###
