"""Initial database

Revision ID: 6ac1a5cd22a5
Revises: 
Create Date: 2022-01-22 10:19:15.852921

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = '6ac1a5cd22a5'
down_revision = None
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('modelo_ner',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.Column('descripcion', sa.Text(), nullable=True),
    sa.Column('ubicacion', sa.String(length=256), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('user',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('name', sa.String(length=80), nullable=False),
    sa.Column('email', sa.String(length=256), nullable=False),
    sa.Column('password', sa.String(length=128), nullable=False),
    sa.Column('is_admin', sa.Boolean(), nullable=True),
    sa.PrimaryKeyConstraint('id'),
    sa.UniqueConstraint('email')
    )
    op.create_table('proyecto',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.Column('descripcion', sa.Text(), nullable=True),
    sa.Column('distancia_palabras', sa.Integer(), nullable=True),
    sa.Column('user_id', sa.Integer(), nullable=False),
    sa.Column('modelo_ner_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['modelo_ner_id'], ['modelo_ner.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['user_id'], ['user.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('documento',
    sa.Column('id', sa.Integer(), nullable=False),
    sa.Column('nombre', sa.String(length=256), nullable=False),
    sa.Column('ubicacion', sa.String(length=256), nullable=True),
    sa.Column('proyecto_id', sa.Integer(), nullable=False),
    sa.ForeignKeyConstraint(['proyecto_id'], ['proyecto.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('id')
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('documento')
    op.drop_table('proyecto')
    op.drop_table('user')
    op.drop_table('modelo_ner')
    # ### end Alembic commands ###
